from typing import Set, Union, Callable, List

import networkx as nx
from evrouting.T import Node, SoC

DistFunction = Callable[[nx.Graph, Node, Node], Union[int, float]]


def shortest_path(G: nx.Graph, s, t, b_0: float, b_t: float, U: float):
    """
    Calculates shortest path using a generalized gas station algorithm.

    :param G: Input Graph
    :param s: Start Node identifier
    :param t: End Node identifier
    :param b_0: Start SoC
    :param b_t: End SoC
    :param U: Capacity
    :return:
    """
    pass


def dijkstra(G: nx.Graph, u: Node, v: Node, weight: str = 'weight') -> Union[int, float]:
    path: List[Node] = nx.algorithms.shortest_path(G, u, v, weight=weight)

    return sum([G.edges[path[i], path[i + 1]][weight] for i in range(len(path) - 1)])


def contract_graph(G: nx.Graph, S: Set[Node], U: SoC,
                   f_dist: DistFunction = dijkstra) -> nx.Graph:
    pass
